# wxBrush Class Reference
[Graphics Device Interface (GDI)]

`#include <wx/brush.h>`

Inheritance diagram for wxBrush:
[legend]

## Detailed Description

A brush is a drawing tool for filling in areas.

It is used for painting the background of rectangles, ellipses, etc. It has a colour and a style.

On a monochrome display, wxWidgets shows all brushes as white unless the colour is really black.

Do not initialize objects on the stack before the program commences, since other required structures may not have been set up yet. Instead, define global pointers to objects and create them in wxApp::OnInit or when required.

An application may wish to create brushes with different characteristics dynamically, and there is the consequent danger that a large number of duplicate brushes will be created. Therefore an application may wish to get a pointer to a brush by using the global list of brushes wxTheBrushList, and calling the member function wxBrushList::FindOrCreateBrush().

This class uses reference counting and copy-on-write internally so that assignments between two instances of this class are very cheap. You can therefore use actual objects instead of pointers without efficiency problems. If an instance of this class is changed it will create its own data internally so that other instances, which previously shared the data using the reference counting, are not affected.

##

Library: wxCore

Category: Graphics Device Interface (GDI)

Predefined objects/pointers:

- wxNullBrush
- wxBLACK_BRUSH
- wxBLUE_BRUSH
- wxCYAN_BRUSH
- wxGREEN_BRUSH
- wxYELLOW_BRUSH
- wxGREY_BRUSH
- wxLIGHT_GREY_BRUSH
- wxMEDIUM_GREY_BRUSH
- wxRED_BRUSH
- wxTRANSPARENT_BRUSH
- wxWHITE_BRUSH

See also:
  wxBrushList, wxDC, wxDC::SetBrush

## Public Member Functions
| wxBrush ()
| Default constructor.
| wxBrush (const wxColour &colour, wxBrushStyle style=wxBRUSHSTYLE_SOLID)
| Constructs a brush from a colour object and style.
| wxBrush (const wxBitmap &stippleBitmap)
| Constructs a stippled brush using a bitmap.
| wxBrush (const wxBrush &brush)
| Copy constructor, uses reference counting.
virtual | ~wxBrush ()
| Destructor.
virtual wxColour | GetColour () const
| Returns a reference to the brush colour.
virtual wxBitmap * | GetStipple () const
| Gets a pointer to the stipple bitmap.
virtual wxBrushStyle | GetStyle () const
| Returns the brush style, one of the wxBrushStyle values.
virtual bool | IsHatch () const
| Returns true if the style of the brush is any of hatched fills.
virtual bool | IsOk () const
| Returns true if the brush is initialised.
bool | IsNonTransparent () const
| Returns true if the brush is a valid non-transparent brush.
bool | IsTransparent () const
| Returns true if the brush is transparent.
virtual void | SetStipple (const wxBitmap &bitmap)
| Sets the stipple bitmap.
virtual void | SetStyle (wxBrushStyle style)
| Sets the brush style.
bool | operator!= (const wxBrush &brush) const
| Inequality operator.
bool | operator== (const wxBrush &brush) const
| Equality operator.
virtual void | SetColour (const wxColour &colour)
| Sets the brush colour using red, green and blue values.
virtual void | SetColour (unsigned char red, unsigned char green, unsigned char blue)
| Sets the brush colour using red, green and blue values.

List of all members.

## Constructor & Destructor Documentation

wxBrush::wxBrush | ( |  | ) |

Default constructor.

The brush will be uninitialised, and wxBrush:IsOk() will return false.

wxBrush::wxBrush | ( | const wxColour & | colour,
|  | wxBrushStyle | style = `wxBRUSHSTYLE_SOLID` |
| ) |  |  |

Constructs a brush from a colour object and style.

Parameters:

  | colour | Colour object.
  | style | One of the wxBrushStyle enumeration values.

wxBrush::wxBrush | ( | const wxBitmap & | stippleBitmap | ) |

Constructs a stippled brush using a bitmap.

The brush style will be set to `wxBRUSHSTYLE_STIPPLE`.

wxBrush::wxBrush | ( | const wxBrush & | brush | ) |

Copy constructor, uses reference counting.

virtual wxBrush::~wxBrush | ( |  | ) | `[virtual]`

Destructor.

See Object Destruction for more info.

Remarks:
  Although all remaining brushes are deleted when the application exits, the application should try to clean up all brushes itself. This is because wxWidgets cannot know if a pointer to the brush object is stored in an application data structure, and there is a risk of double deletion.

## Member Function Documentation

virtual wxColour wxBrush::GetColour | ( |  | ) | const`[virtual]`

Returns a reference to the brush colour.

See also:
  SetColour()

virtual wxBitmap* wxBrush::GetStipple | ( |  | ) | const`[virtual]`

Gets a pointer to the stipple bitmap.

If the brush does not have a `wxBRUSHSTYLE_STIPPLE` style, this bitmap may be non-NULL but uninitialised (i.e. wxBitmap:IsOk() returns false).

See also:
  SetStipple()

virtual wxBrushStyle wxBrush::GetStyle | ( |  | ) | const`[virtual]`

Returns the brush style, one of the wxBrushStyle values.

See also:
  SetStyle(), SetColour(), SetStipple()

virtual bool wxBrush::IsHatch | ( |  | ) | const`[virtual]`

Returns true if the style of the brush is any of hatched fills.

See also:
  GetStyle()

bool wxBrush::IsNonTransparent | ( |  | ) | const

Returns true if the brush is a valid non-transparent brush.

This method returns true if the brush object is initialized and has a non-transparent style. Notice that this should be used instead of simply testing whether GetStyle() returns a style different from wxBRUSHSTYLE_TRANSPARENT if the brush may be invalid as GetStyle() would assert in this case.

See also:
  IsTransparent()

Since:
  2.9.2.

virtual bool wxBrush::IsOk | ( |  | ) | const`[virtual]`

Returns true if the brush is initialised.

Notice that an uninitialized brush object can't be queried for any brush properties and all calls to the accessor methods on it will result in an assert failure.

bool wxBrush::IsTransparent | ( |  | ) | const

Returns true if the brush is transparent.

A transparent brush is simply a brush with wxBRUSHSTYLE_TRANSPARENT style.

Notice that this function works even for non-initialized brushes (for which it returns false) unlike tests of the form `GetStyle() == wxBRUSHSTYLE_TRANSPARENT` which would assert if the brush is invalid.

See also:
  IsNonTransparent()

Since:
  2.9.2.

bool wxBrush::operator!= | ( | const wxBrush & | brush | ) | const

Inequality operator.

See Object Comparison for more info.

bool wxBrush::operator== | ( | const wxBrush & | brush | ) | const

Equality operator.

See Object Comparison for more info.

virtual void wxBrush::SetColour | ( | unsigned char | red,
|  | unsigned char | green,
|  | unsigned char | blue |
| ) |  |  | `[virtual]`

Sets the brush colour using red, green and blue values.

See also:
  GetColour()

virtual void wxBrush::SetColour | ( | const wxColour & | colour | ) | `[virtual]`

Sets the brush colour using red, green and blue values.

See also:
  GetColour()

virtual void wxBrush::SetStipple | ( | const wxBitmap & | bitmap | ) | `[virtual]`

Sets the stipple bitmap.

Parameters:

  | bitmap | The bitmap to use for stippling.

Remarks:
  The style will be set to `wxBRUSHSTYLE_STIPPLE`, unless the bitmap has a mask associated to it, in which case the style will be set to `wxBRUSHSTYLE_STIPPLE_MASK_OPAQUE`.

See also:
  wxBitmap

virtual void wxBrush::SetStyle | ( | wxBrushStyle | style | ) | `[virtual]`

Sets the brush style.

Parameters:

  | style | One of the wxBrushStyle values.

See also:
  GetStyle()

|  | [ top ]